<template>
  <div>
    <h1 class="text-center mt-5">Création de compte</h1>
    <v-alert dense text type="success" v-if="isSignup">Inscription ok</v-alert>
    <div class="ma-5">
      <validation-observer ref="observer" v-slot="{ invalid }">
        <form @submit.prevent="submit">
          <validation-provider
            v-slot="{ errors }"
            name="last_name"
            rules="required|max:20"
          >
            <v-text-field
              v-model="form.last_name"
              :counter="20"
              :error-messages="errors"
              label="Nom"
              required
            ></v-text-field>
          </validation-provider>
          <validation-provider
            v-slot="{ errors }"
            name="first_name"
            rules="required|max:20"
          >
            <v-text-field
              v-model="form.first_name"
              :counter="20"
              :error-messages="errors"
              label="Prénom"
              required
            ></v-text-field>
          </validation-provider>
          <validation-provider
            v-slot="{ errors }"
            name="nickname"
            rules="required|max:10"
          >
            <v-text-field
              v-model="form.nickname"
              :counter="10"
              :error-messages="errors"
              label="Pseudo"
              required
            ></v-text-field>
          </validation-provider>
          <validation-provider
            v-slot="{ errors }"
            name="phone"
            :rules="{
              required: true,
              digits: 10,
            }"
          >
            <v-text-field
              v-model="form.phone"
              :counter="10"
              :error-messages="errors"
              label="Numéro de téléphone"
              required
            ></v-text-field>
          </validation-provider>
          <validation-provider
            v-slot="{ errors }"
            name="email"
            rules="required|email"
          >
            <v-text-field
              v-model="form.email"
              :error-messages="errors"
              label="E-mail"
              required
            ></v-text-field>
          </validation-provider>
          <validation-provider v-slot="{ errors }" name="adress">
            <v-text-field
              v-model="form.adress"
              :error-messages="errors"
              label="Adresse"
            ></v-text-field>
          </validation-provider>
          <validation-provider v-slot="{ errors }" name="avatar">
            <v-text-field
              v-model="form.avatar"
              :error-messages="errors"
              label="Avatar"
            ></v-text-field>
          </validation-provider>
          <validation-provider v-slot="{ errors }" name="password">
            <v-text-field
              v-model="form.password"
              :error-messages="errors"
              label="Mot de passe"
            ></v-text-field>
          </validation-provider>
          <v-btn class="mr-4" type="submit" :disabled="invalid">
            submit
          </v-btn>
          <v-btn @click="clear">
            clear
          </v-btn>
        </form>
      </validation-observer>
    </div>
  </div>
</template>

<script>
import axios from "axios";
import { required, digits, email, max, regex } from "vee-validate/dist/rules";
import {
  extend,
  ValidationObserver,
  ValidationProvider,
  setInteractionMode,
} from "vee-validate";

setInteractionMode("eager");

extend("digits", {
  ...digits,
  message: "{_field_} needs to be {length} digits. ({_value_})",
});

extend("required", {
  ...required,
  message: "{_field_} can not be empty",
});

extend("max", {
  ...max,
  message: "{_field_} may not be greater than {length} characters",
});

extend("regex", {
  ...regex,
  message: "{_field_} {_value_} does not match {regex}",
});

extend("email", {
  ...email,
  message: "Email must be valid",
});

export default {
  name: "signUp",
  components: {
    ValidationProvider,
    ValidationObserver,
  },
  data() {
    return {
      form: {
        last_name: "",
        first_name: "",
        nickname: "",
        adress: "",
        phone: "",
        email: "",
        avatar: "",
        password: "",
      },
      isSignup: false,
    };
  },
  show: true,
  methods: {
    submit() {
      this.$refs.observer.validate();
      axios({
        method: "post",
        url: "http://localhost:8081/users/sign-up",
        data: this.form,
      })
        .then((response) => {
          console.log(response);
        })
        .catch((error) => {
          console.log(error);
        });
      let that = this;
      that.form.last_name = "";
      that.form.first_name = "";
      that.form.nick_name = "";
      that.form.adress = "";
      that.form.phone = "";
      that.form.email = "";
      that.form.avatar = "";
      that.form.password = "";
      that.isSignup = true;
    },
    clear() {
      this.form.last_name = "";
      this.form.first_name = "";
      this.form.nickname = "";
      this.form.adress = "";
      this.form.phone = "";
      this.form.email = "";
      this.form.avatar = "";
      this.form.password = "";
      this.form.$refs.observer.reset();
    },
  },
};
</script>

<style scoped></style>
